# frozen_string_literal: true

require 'rails_helper'

describe Entry::Persist, type: :model do
  let(:test_title) { 'Gummibärenbande im Kölner Dom' }
  let(:test_slug) { 'gummibaerenbande-im-koelner-dom' }
  let(:other_slug) { 'other-slug' }

  describe '#generate_slug' do
    context 'new entry' do
      let(:entry) { Entry::Persist.new(EntryWithTitle, title: test_title, slug: '').prepare.resource }

      it 'fills slug based on title' do
        expect(entry.slug).to eq(test_slug)
      end
    end

    context 'existing entry' do
      let(:entry) do
        Entry::Persist.new(
          EntryWithTitle.new(slug: other_slug),
          title: test_title, slug: '',
        ).prepare.resource
      end

      it 'does not change existing slug' do
        expect(entry.slug).to eq(other_slug)
      end
    end

    context 'no slug submitted' do
      let(:entry) { Entry::Persist.new(EntryWithTitle, title: test_title).prepare.resource }

      it 'does not genereate slug' do
        expect(entry.slug).to be_nil
      end
    end
  end
end

class EntryWithTitle < Entry
  # Slug is generated by parameterizing the title attribute, if available, otherwise its nil
  attr_accessor :title
end
